#!/usr/bin/python
# -*- coding: utf-8 -*-
##   glossary.py 
##
##   Author: Saeed Rasooli <saeed.gnu@gmail.com>  (ilius)
##   Thanks to 'Pier Carteri' <m3tr0@dei.unipd.it> for program Py_Shell.py
##   Thanks to 'Milad Rastian' for program pySQLiteGUI
##
##   This program is a free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 3, or (at your option)
##   any later version.
##
##   You can get a copy of GNU General Public License along this program
##   But you can always get it from http://www.gnu.org/licenses/gpl.txt
##
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.

import sys, os, gtk, thread
from glossary import *

stderr_saved = sys.stderr
stdout_saved = sys.stdout

startBold = '\x1b[1m'      # len=4
startUL   = '\x1b[4m'      # len=4
endFormat = '\x1b[0;0;0m'  # len=8
#redOnGray = '\x1b[0;1;31;47m'

if os.sep=='/':
  homeDir = os.getenv('HOME')
  tmpDir  = '/tmp'
  user    = os.getenv('USER')
elif os.sep=='\\':
  #homeDir = 'C:'+os.getenv('HOMEPATH')
  homeDir = os.getenv('APPDATA')
  tmpDir  = os.getenv('TEMP')
  user    = os.getenv('USERNAME')
else:
  raise RuntimeError, 'bad seperator (os.sep=="%s")'%os.sep
"""
fifoPath='%s%spyglossary-fifo-%s'%(tmpDir,os.sep,user)
try:
  os.mkfifo(fifoPath)
except:
  pass
"""
initCwd = os.getcwd()
srcDir = os.path.dirname(sys.argv[0])
rootDir = os.path.dirname(srcDir)
libDir=os.path.join(rootDir,'dependencies','py2.5-lib')
use_psyco_file='%s%suse_psyco'%(srcDir,os.sep)
psyco_found=None

if os.path.isdir(libDir):
  sys.path.append(libDir)

#tmpFilePath='/tmp/glossary_tmp'
#tmpFile = file(tmpFilePath,'w')
##tmpXmlFile = XMLGenerator(tmpFile, 'utf-8')

def runDictzip(filename):
      p3 = os.popen3('dictzip')
      (out, err) = (p3[1].read(),p3[2].read())
      print 'out="%s"\terr="%s"'%(out, err)
      if err=="":
        dictzipCmd='dictzip'
      else:
        #dictzipCmd='%s%sdependencies%sdictzip'%(rootDir,os.sep,os.sep)
        dictzipCmd=os.path.join(rootDir,'dependencies','dictzip')
      if filename[-4:]=='.ifo':
        filename = filename[:-4]
      p3 = os.popen3("%s '%s.dict'"%(dictzipCmd,filename))
      (out, err) = (p3[1].read(),p3[2].read())
      print 'diczip command: "%s"'%dictzipCmd
      if err!='':
        printAsError('dictzip error: %s'%err.replace('\n',' '))
      if out!='':
        print 'dictzip error: %s'%out.replace('\n',' ')



## Thanks to 'Pier Carteri' <m3tr0@dei.unipd.it> for program Py_Shell.py
class DummyFile:
    ## Implements a file-like object for redirect the stream to the buffer
    def __init__(self, buff, tag):
      (self.buffer,self.tag) = (buff,tag)
    ## Write text into the buffer and apply self.tag
    def write(self, text):
        iter=self.buffer.get_end_iter()
        self.buffer.insert_with_tags(iter,text,self.tag)
    writelines = lambda self, l: map(self.write, l)
    flush = lambda self: None
    isatty = lambda self: 1

class MainDialog:
  def def_widgets(self, names):
    for name in names:
      #try:
      exec('self.%s=self.xml.get_widget("%s")'%(name,name))
      #except:
      #  print name
        #sys.exit(1)
  def __init__(self):
    #self.xml= gtk.glade.XML('%s%sglade%smaindialog.glade'%(srcDir,os.sep,os.sep))
    self.xml= gtk.glade.XML(os.path.join(srcDir,'glade','maindialog.glade'))
    self.d = self.xml.get_widget('maindialog.glade')
    try:
      self.d.set_icon_from_file('%s%spyglossary.png'%(srcDir,os.sep))
    except:
      pass
    signals={}##{'browse1':self.browse1}
    for attr in dir(self):
      signals[attr] = getattr(self, attr)
    self.xml.signal_autoconnect(signals)
    self.def_widgets(['textview_out','textview_err','maindialog','vpaned1','notebook1','entry_i','entry_o',\
      'combobox_i','combobox_o','checkb_o_det','combobox_r_i',\
      'entry_r_i','entry_r_o','combobox_sr','progressbar','textview_edit',\
      'label_convert','label_reverse','combobox_mode','textview_merge','button_conv'])
    
    """## changing colors
    self.textview_err.modify_base(0, gtk.gdk.Color(10000, 0, 0))#textview bg color
    #self.textview_err.modify_base(1, gtk.gdk.Color(-1, 0, 0))#selected text bg color, when deselect window!
    self.textview_err.modify_text(0, gtk.gdk.Color(-1, -1, -1))#normal text color
    #self.textview_err.modify_text(1, gtk.gdk.Color(-1, -1, -1))#selected test color, when deselect window!
    # modify_bg modify_fg 
    self.textview_out.modify_base(0, gtk.gdk.Color(0, 10000, 0))#textview bg color
    self.textview_out.modify_text(0, gtk.gdk.Color(-1, -1, -1))#normal text color
    """
    self.running = False
    self.path = ''
    self.glos=Glossary()
    self.glos.ui = self
    for f in Glossary.readFormats:
      self.combobox_i.append_text(Glossary.formatsDesc[f])
      self.combobox_r_i.append_text(Glossary.formatsDesc[f])
    for f in Glossary.writeFormats:
      self.combobox_o.append_text(Glossary.formatsDesc[f])
    self.combobox_sr.set_active(0)
    #self.xml.get_widget('checkb_i_ext').set_active(0)
    #self.xml.get_widget('checkb_o_ext').set_active(1)
    self.xml.get_widget('combobox_c_case').set_active(0)
    self.dbe_init()
    self.editor_path=''
    self.tabIndex=0
    self.fcd_dir = ''
    ###################################
    t_table = gtk.TextTagTable()
    tag = gtk.TextTag("filelist")
    t_table.add(tag)
    self.merge_buffer = gtk.TextBuffer(t_table)
    self.textview_merge.set_buffer(self.merge_buffer)
    self.merge_buffer.connect('changed', self.textview_merge_changed)
    self.combobox_mode.set_active(2)
    ####################################
    self.reverseStop = False
    self.pref_init()
    #thread.start_new_thread(MainDialog.progressListen,(self,))
    #################### Comment folowing two line to see the output in the terminal
    self.redirectStdOut()
    self.redirectStdErr()
  def textview_merge_changed(self, *args):
    (stderr,sys.stderr) = (sys.stderr,stderr_saved)
    b = self.merge_buffer
    lines = b.get_text(b.get_start_iter(),b.get_end_iter()).split('\n')
    for i in range(len(lines)):
      if len(lines[i])>7:
        if lines[i][:7]=='file://':
          lines[i]=urlToPath(lines[i])
    if lines[-1]=='':
      lines.pop(-1)
    b.set_text('\n'.join(lines))
    sys.stderr = stderr
  def show_msg(self,key,icon="error",buttons="close"):
        ## From program pySQLiteGUI writen by 'Milad Rastian'
        ## Show message dialog
        msgicon=0
        msgbuttons=0
        if icon=="error":
            msgicon=gtk.MESSAGE_ERROR
        elif icon=="info":
            msgicon=gtk.MESSAGE_INFO
        elif icon=="question":
            msgicon=gtk.MESSAGE_QUESTION
        elif icon=="warning":
            msgicon=gtk.MESSAGE_WARNING
        if buttons=="close":
            msgbuttons=gtk.BUTTONS_CLOSE
        elif buttons=="yesno":
            msgbuttons=gtk.BUTTONS_YES_NO
        msgWindow=gtk.MessageDialog(None,0,msgicon,msgbuttons,ERRORS[key][0] )
        msgWindow.format_secondary_text(ERRORS[key][1])
        response=msgWindow.run()
        msgWindow.destroy()
        return response
################ Redirecting standart output and standard error #################
##############    Using program Py_Shell.py writen by Pier Carteri     ##########
  def redirectStdOut(self):							#
    t_table_out = gtk.TextTagTable()						#
    tag_out = gtk.TextTag("output")						#
    t_table_out.add(tag_out)							#
    self.buffer_out = gtk.TextBuffer(t_table_out)				#
    self.textview_out.set_buffer(self.buffer_out)				#
    self.dummy_out = DummyFile(self.buffer_out,tag_out)				#
    sys.stdout = self.dummy_out							#
    print 'Output console:'							#
  def redirectStdErr(self):							#
    t_table_err = gtk.TextTagTable()						#
    tag_err = gtk.TextTag("error")						#
    t_table_err.add(tag_err)							#
    self.buffer_err = gtk.TextBuffer(t_table_err)				#
    self.textview_err.set_buffer(self.buffer_err)				#
    self.dummy_err = DummyFile(self.buffer_err,tag_err)				#
    sys.stderr = self.dummy_err							#
    printAsError('Error console:')						#
  def redirectStdOutErrToOne(self):						#
    t_table_rev = gtk.TextTagTable()						#
    tag_out = gtk.TextTag("output")						#
    t_table_rev.add(tag_out)							#
    tag_err = gtk.TextTag("error")						#
    t_table_rev.add(tag_err)							#
    self.buffer_rev = gtk.TextBuffer(t_table_rev)				#
    self.textview_rev.set_buffer(self.buffer_rev)				#
    self.dummy_rev_out = DummyFile(self.buffer_rev,tag_out)			#
    sys.stdout = self.dummy_rev_out						#
    self.dummy_rev_err = DummyFile(self.buffer_rev,tag_err)			#
    sys.stderr = self.dummy_rev_err						#
  def restoreStdOutErr(self):							#
    (sys.stdout,sys.stderr) = (stdout_saved,stderr_saved)			#
#################################################################################
  #def maindialog_resized(self, *args):
  #  self.vpaned1.set_position(185)
  #  print args
  run=lambda self:gtk.main()
  #ok_clicked=lambda self, *args: pass
  def apply_clicked(self, *args):
    i = self.tabIndex
    if i==0:
      if self.load():
        self.convert_clicked()
    elif i==1:
      if self.r_load():
        self.r_start()
    elif i==3:
      self.dbe_update()
    elif i==4:
      self.pref_update()
      print 'Preferences updated'
  def close(self, *args):
    if self.running:
      self.xml.get_widget('quitdialog').show()
      return True
    else:
      self.quit()
  close_button_clicked=close
  quitdialog_close=lambda self, *args: self.xml.get_widget('quitdialog').hide()
  #quit=lambda self, *args: sys.exit(0)
  def quit(self, *args):
    self.pref_update()
    self.pref_save()
    sys.exit(0)
  quitdialog_close=lambda self, *args: self.xml.get_widget('quitdialog').hide()
  #def help_clicked(self, *args):
  #  HelpDialog().run()
  def browse_i(self, *args):
    FileChooserDialog(self, action='open').run()
    if not self.path in ('',None):
      self.entry_i.set_text(self.path)
      self.fcd_dir = os.path.dirname(self.path)
      self.path = ''
  def browse_o(self, *args):
    FileChooserDialog(self, action='save').run()
    if not self.path in ('',None):
      self.entry_o.set_text(self.path)
      self.fcd_dir = os.path.dirname(self.path)
      self.path = ''
  def load(self, *args):
    iPath = self.entry_i.get_text()
    if iPath=='':
      printAsError('Input file path is empty!');return
    formatD = self.combobox_i.get_active_text()
    if formatD==None:
      #printAsError('Input format is empty!');return
      format=''
    else:
      format = Glossary.descFormat[formatD]
    print 'Reading from %s, please wait...'%formatD
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    t0=time.time()
    if formatD[:7]=='Omnidic':
      dicIndex=self.xml.get_widget('spinbutton_omnidic_i').get_value_as_int()
      ex = self.glos.readOmnidic(iPath, dicIndex=dicIndex)
    else:
      ex = self.glos.read(iPath, format=format)
    if ex:
      print 'reading %s file: "%s"  done.\n%d words found.'%(format,iPath,len(self.glos.data))
    else:
      print 'reading %s file: "%s"  failed.'%(format,iPath)
      return False
    #self.iFormat = format
    self.iPath = iPath
    self.button_conv.set_sensitive(True)
    if self.pref['sort']:
      self.glos.data.sort()
    if self.pref['remove_tags']:
      self.glos.removeTags()
    if self.checkb_o_det.get_active():
      print 'time left = %3f  seconds'%(time.time()-t0)
      for x in self.glos.info:
        print '%s="%s"'%x
    self.glos.replaceInDefinitions((('ي','ی'),('ك','ک')))
    return True
  def load_m(self, *args):
    b = self.merge_buffer
    text = b.get_text(b.get_start_iter(),b.get_end_iter())
    if text=='':
      return
    paths = text.split('\n')
    n = len(paths)
    if n==0:
      return
    mode=self.combobox_mode.get_active()
    for i in range(n):
      g = Glossary()
      g.read(paths[i])
      if mode==0:
        self.glos = self.glos.attach(g)
      elif mode==1:
        self.glos = self.glos.merge(g)
      elif mode==2:
        self.glos = self.glos.deepMerge(g)
      del g
      try:
        self.progress(float(i+1)/n, '%s / %s files loaded'%(i+1,n))
      except:
        pass
      if i==0:
        self.button_conv.set_sensitive(True)
      while gtk.events_pending():
        gtk.main_iteration_do(False)
  def convert_clicked(self, *args):
    #if self.running:
    #  printAsError('Can not convert glossary, because another operation is running. '+\
    #    'Please open a new PyGlossary window, or wait until that operation be completed.')
    #  return False
    if len(self.glos.data)==0:
      printAsError('Input glossary has no word! Be sure to click "Load" before "Convert", '+\
        'or just click "Apply" instead.')
      return False
    oPath = self.entry_o.get_text()
    if oPath=='':
      printAsError('Output file path is empty!');return
    formatD = self.combobox_o.get_active_text()
    if formatD in (None,''):
      printAsError('Output format is empty!');return
    print 'Converting to %s, please wait...'%formatD
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    self.running=True
    format = Glossary.descFormat[formatD]
    t0=time.time()
    if formatD[:8]=='StarDict':
        if self.xml.get_widget('checkb_o_ext').get_active():
          self.glos.writeStardict(oPath)
        else:
          self.glos.writeStardict_int(oPath)
    elif formatD[:7]=='Omnidic':
        dicIndex=self.xml.get_widget('spinbutton_omnidic_o').get_value_as_int()
        self.glos.writeOmnidic(oPath, dicIndex=dicIndex)
    elif formatD[:7]=='Babylon':
        encoding = self.xml.get_widget('comboentry_enc').get_active_text()
        self.glos.writeBabylon(oPath, encoding=encoding)
    else:
      self.glos.write(oPath, format=format)
    #self.oFormat = format
    self.oPath = oPath
    print 'writing %s file: "%s" done.'%(format,oPath)
    if self.checkb_o_det.get_active():
      print 'time left = %3f  seconds'%(time.time()-t0)
    self.running=False
    return True

  def combobox_i_changed(self, *args):
    formatD = self.combobox_i.get_active_text().lower()
    """
    if format[:8]=='stardict':
      #self.xml.get_widget('checkb_i_ext').show()
      pass
    else:
      self.xml.get_widget('checkb_i_ext').hide()
    """
    if formatD[:7]=='omnidic':
      self.xml.get_widget('label_omnidic_i').show()
      self.xml.get_widget('spinbutton_omnidic_i').show()
    else:
      self.xml.get_widget('label_omnidic_i').hide()
      self.xml.get_widget('spinbutton_omnidic_i').hide()

  def combobox_o_changed(self, *args):
    formatD = self.combobox_o.get_active_text().lower()
    if formatD[:7]=='omnidic':
      self.xml.get_widget('label_omnidic_o').show()
      self.xml.get_widget('spinbutton_omnidic_o').show()
    else:
      self.xml.get_widget('label_omnidic_o').hide()
      self.xml.get_widget('spinbutton_omnidic_o').hide()
    if formatD[:7]=='babylon':
      self.xml.get_widget('label_enc').show()
      self.xml.get_widget('comboentry_enc').show()
    else:
      self.xml.get_widget('label_enc').hide()
      self.xml.get_widget('comboentry_enc').hide()
    if formatD[:8]=='stardict':
      self.xml.get_widget('checkb_o_ext').show()
    else:
      self.xml.get_widget('checkb_o_ext').hide()
    if self.pref['auto_set_out']:#format==None:
      pathI = self.entry_i.get_text()
      pathO = self.entry_o.get_text()
      formatOD = self.combobox_o.get_active_text()
      if formatOD != None and pathO=='' and '.' in pathI:
        extO=Glossary.descExt[formatOD]
        pathO=''.join(os.path.splitext(pathI)[:-1])+extO
        self.entry_o.set_text(pathO)
  def entry_i_changed(self,*args):
    pathI = self.entry_i.get_text()
    formatD = self.combobox_i.get_active_text()
    if len(pathI)>7:
      if pathI[:7]=='file://':
        pathI=urlToPath(pathI)
        self.entry_i.set_text(pathI)
    if self.pref['auto_set_for']:#format==None:
      pathI = self.entry_i.get_text()
      ext = os.path.splitext(pathI)[-1].lower()
      if ext in ('.gz','.bz2','.zip'):
        ext = os.path.splitext(pathI[:-len(ext)])[-1].lower()
      for i in range(len(Glossary.readExt)):
        if ext in Glossary.readExt[i]:
          self.combobox_i.set_active(i)
          break
    if self.pref['auto_set_out']:#format==None:
      #pathI = self.entry_i.get_text()
      formatOD = self.combobox_o.get_active_text()
      pathO    = self.entry_o.get_text()
      if formatOD != None and pathO=='' and '.' in pathI:
        extO=Glossary.descExt[formatOD]
        pathO=''.join(os.path.splitext(pathI)[:-1])+extO
        self.entry_o.set_text(pathO)
  def entry_o_changed(self,*args):
    pathO = self.entry_o.get_text()
    if pathO=='':
      return
    #format = self.combobox_o.get_active_text()
    if len(pathO)>7:
      if pathO[:7]=='file://':
        pathO=urlToPath(pathO)
        self.entry_o.set_text(pathO)
    if True:#format==None:   
      pathO = self.entry_o.get_text()
      extO = os.path.splitext(pathO)[-1].lower()
      if extO in ('.gz','.bz2','.zip'):
        ext = os.path.splitext(pathO[:-len(extO)])[-1].lower()
      for i in range(len(Glossary.writeExt)):
        if extO in Glossary.writeExt[i]:
          self.combobox_o.set_active(i)
          break
  #################################
  def browse_m(self, *args):
    fcd=FileChooserDialog(self, action='open', multiple=True)
    #if fcd.run() != gtk.RESPONSE_ACCEPT:
    #  return
    fcd.run()
    filelist = fcd.fd.get_filenames()
    text=self.merge_buffer.get_text(self.merge_buffer.get_start_iter(),self.merge_buffer.get_end_iter())
    if text!='':
      text += '\n'
    text += '\n'.join(filelist)
    self.merge_buffer.set_text(text)
    #self.fcd_dir = os.path.dirname(self.path)
    self.path = ''

  #################################
  def tab_switched(self, *args):
    ##oldTabIndex = self.xml.get_widget('notebook1').get_current_page()
    i = self.tabIndex = args[-1]
    if i==1:
      self.xml.get_widget('button_r_d').set_sensitive(True)#show()
      self.xml.get_widget('button_apply').set_sensitive(False)
    else:
      self.xml.get_widget('button_r_d').set_sensitive(False)#hide()
      self.xml.get_widget('button_apply').set_sensitive(True)
    if i in (0,1):
      #self.notebook1.set_resize_mode(0)
      pass
    else:
      pass
  clear_output=lambda self, *args: self.buffer_out.set_text('Output console:\n')
  clear_errors=lambda self, *args: self.buffer_err.set_text('Error console:\n')
  #######################################################
  ################################# Reverse tab:
  def r_browse_i(self, *args):
    FileChooserDialog(self, action='open').run()
    if not self.path in ('',None):
      self.entry_r_i.set_text(self.path)
      self.fcd_dir = os.path.dirname(self.path)
      self.path = ''
  def r_browse_o(self, *args):
    FileChooserDialog(self, action='save').run()
    if not self.path in ('',None):
      self.entry_r_o.set_text(self.path)
      self.fcd_dir = os.path.dirname(self.path)
      self.path = ''
  def entry_r_i_changed(self,*args):
    format=self.combobox_r_i.get_active_text()
    path = self.entry_r_i.get_text()
    if len(path)>7:
      if path[:7]=='file://':
        path=urlToPath(path)
        self.entry_r_i.set_text(path)
    if True:#format==None:
      path = self.entry_r_i.get_text()
      ext = os.path.splitext(path)[-1].lower()
      if ext in ('.gz','.bz2','.zip'):
        ext = os.path.splitext(path[:-len(ext)])[-1].lower()
      for i in range(len(Glossary.readExt)):
        if ext in Glossary.readExt[i]:
          self.combobox_r_i.set_active(i)
          self.entry_r_o.set_text(os.path.splitext(path)[0]+'-reversed.txt')
          return      
  def r_load(self, *args):
    #if self.running:
    #  printAsError('Can not load glossary, because another operation is running. '+\
    #    'Please open a new PyGlossary window, or wait until that operation be completed.')
    #  return False
    iPath = self.entry_r_i.get_text()
    formatD = self.combobox_r_i.get_active_text()
    if iPath=='':
      printAsError('Input file path is empty!');return False
    if formatD in (None,''):
      printAsError('Input format is empty!');return
    print 'Reading from %s, please wait...'%formatD
    format = Glossary.descFormat[formatD]
    self.glosR = Glossary()
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    t0=time.time()
    self.glosR.read(iPath, format=format)
    if self.checkb_o_det.get_active():
      print 'time left = %3f  seconds'%(time.time()-t0)
      for x in self.glos.info:
        print '%s="%s"'%x
    self.glosR.replaceInDefinitions((('ي','ی'),('ك','ک')))
    self.glosR.ui = self
    #self.riFormat = format
    #self.riPath = iPath
    self.glosR.replaceInDefinitions((('ي','ی'),('ك','ک')))
    print 'reading %s file: "%s" done.\n%d words found.'%(formatD,iPath,len(self.glosR.data))
    self.running=False ; return True
  def r_dynamic_button_clicked(self, *args):
    text=self.xml.get_widget('label_r_d').get_text()
    if text=='Start':
      self.r_start()
    elif text=='Stop':
      self.r_stop()
    elif text=='Resume':
      self.r_resume()
    else:
      raise RuntimeError, 'unknown label %s on dynamic button!'%text
  def r_start(self, *args):
    #if self.running:
    #  printAsError('Can not start glossary reversing, because another operation is running. '+\
    #    'Please open a new PyGlossary window, or wait until that operation be completed.')
    #  return False
    try:
      self.glosR
    except AttributeError:
      if not self.r_load():
        return False
    #if len(self.glosR.data)==0:
    #  printAsError('Input glossary has no word! Be sure to click "Load" before "Start", or just click "Apply" instead.')
    #  return
    oPath = self.entry_r_o.get_text()
    if oPath=='':
      printAsError('Output file path is empty!');return
    self.progressbar.set_text('Starting....')
    #self.progressbar.update(0)
    self.opt={}
    if self.xml.get_widget('checkb_mw').get_active():
      self.opt['matchWord']=True
    showRel = self.combobox_sr.get_active_text()
    if showRel!=None:
      self.opt['showRel']=showRel
    #self.progressbar.set_activity_blocks(100)
    self.opt['autoSaveStep']=int(self.xml.get_widget('spinbutton_autosave').get_value())##get_value() returns a float
    self.opt['minRel']=self.xml.get_widget('spinbutton_minrel').get_value()/100.0
    self.opt['maxNum']=int(self.xml.get_widget('spinbutton_maxnum').get_value())
    self.opt['savePath']=oPath
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    self.rWords = self.glosR.takeOutputWords()
    self.running=True
    #revTh = thread.start_new_thread(self.glosR.reverseDic, (self.rWords, self.opt))
    self.xml.get_widget('image_r_d').set_from_stock('gtk-media-pause', 'button')
    self.xml.get_widget('label_r_d').set_text('Stop')
    self.entry_r_i.set_editable(False)
    self.entry_r_o.set_editable(False)
    self.xml.get_widget('button_r_i').set_sensitive(False)
    self.xml.get_widget('button_r_load').set_sensitive(False)
    self.xml.get_widget('button_r_o').set_sensitive(False)
    self.xml.get_widget('vbox_options').set_sensitive(False)
    self.glosR.reverseDic(self.rWords, self.opt)
    while True:
    #while not self.reverseStop:
      while gtk.events_pending():
        gtk.main_iteration_do(False)
  def r_stop(self, *args):
    self.reverseStop = True
    self.xml.get_widget('image_r_d').set_from_stock('gtk-media-play', 'button')
    self.xml.get_widget('label_r_d').set_text('Resume')
    self.xml.get_widget('vbox_options').set_sensitive(True)
  def r_resume(self, *args):
    if self.glosR.stoped==True:
      self.opt['autoSaveStep']=int(self.xml.get_widget('spinbutton_autosave').get_value())
      self.reverseStop = False
      #revTh = thread.start_new_thread(self.glosR.reverseDic, (self.rWords, self.opt))
      self.xml.get_widget('image_r_d').set_from_stock('gtk-media-pause', 'button')
      self.xml.get_widget('label_r_d').set_text('Stop')
      self.xml.get_widget('vbox_options').set_sensitive(False)
      self.glosR.reverseDic(self.rWords, self.opt)
      while True:
      #while not self.reverseStop:
        while gtk.events_pending():
          gtk.main_iteration_do(False)
    else:
      print 'self.glosR.stoped=%s'%self.glosR.stoped
      print 'Not stoped yet. Wait many seconds and press "Resume" again...'
  def r_finished(self, *args):
    self.glosR.continueFrom=0
    self.running=False
    self.xml.get_widget('image_r_d').set_from_stock('gtk-media-play', 'button')
    self.xml.get_widget('label_r_d').set_text('Start')
    self.entry_r_i.set_editable(True)
    self.entry_r_o.set_editable(True)
    self.xml.get_widget('button_r_i').set_sensitive(True)
    self.xml.get_widget('button_r_load').set_sensitive(True)
    self.xml.get_widget('button_r_o').set_sensitive(True)
    self.xml.get_widget('vbox_options').set_sensitive(True)
    self.progressbar.set_text('Reversing completed')
    print "Reversing completed."
    #thread.exit_thread() # ???????????????????????????
    ## A PROBLEM: CPU is busy even when reversing completed!

  #######################################################################################
  #######################################################################################

  def editor_open(self, *args):
    step=1000
    fcd = FileChooserDialog(self, action='open')
    fcd.run()
    if self.path in ('',None):
      return
    self.editor_path = self.path
    self.fcd_dir = os.path.dirname(self.path)
    self.path = ''
    text = file(self.editor_path).read()
    self.path = ''
    t_table = gtk.TextTagTable()
    tag = gtk.TextTag("output")
    t_table.add(tag)
    self.editor_buffer = gtk.TextBuffer(t_table)
    self.textview_edit.set_buffer(self.editor_buffer)
    self.running = True
    size=len(text)
    if size < step:
      self.editor_buffer.set_text(text)
    else:
      self.editor_buffer.set_text(text[:step])
      while gtk.events_pending():
        gtk.main_iteration_do(False)
      i=step
      while i < size-step:
        self.editor_buffer.insert(self.editor_buffer.get_end_iter(), text[i:i+step])
        i += step
        while gtk.events_pending():
          gtk.main_iteration_do(False)
      self.editor_buffer.insert(self.editor_buffer.get_end_iter(), text[i:])

    
  def editor_save(self, *args):
    exit = self.editor_save_as(self.editor_path)
    if exit==True:
      print 'File saved: "%s"'%self.editor_path
      return True
    elif exit==False:
      print 'File not saved: "%s"'%self.editor_path
      return False
    else:
      return exit
  def editor_save_as(self, *args):
    if type(args[0])==str and args[0]!='':
      self.editor_path = args[0]
    else:
      fcd = FileChooserDialog(self, action='save')
      fcd.run()
      if self.path in ('',None):
        return
      self.editor_path = self.path
      self.fcd_dir = os.path.dirname(self.path)
      self.path = ''
    file(self.editor_path,'w').write(self.editor_buffer.get_text(self.editor_buffer.get_start_iter(),self.editor_buffer.get_end_iter()))
    self.running = False
    return True
  #######################################################################################
  #################################     DB Editor    ####################################
  def dbe_init(self, *args):
    self.entry_dbe = self.xml.get_widget('entry_dbe')
    self.checkb_db_ro = self.xml.get_widget('checkb_db_ro')
    self.entry_db_index = self.xml.get_widget('entry_db_index')
    self.textview_dbe = self.xml.get_widget('textview_dbe')
    self.treeview = self.xml.get_widget('treeview')
    table = gtk.TextTagTable()
    tag = gtk.TextTag('definition')
    table.add(tag)
    self.buffer_dbe = gtk.TextBuffer(table)
    self.textview_dbe.set_buffer(self.buffer_dbe)
    self.treestore = gtk.ListStore(str,str)
    self.treeview.set_model(self.treestore)
    self.cell = gtk.CellRendererText()
    self.cell2 = gtk.CellRendererText()
    col = gtk.TreeViewColumn('Word',self.cell,text=0)
    col2 = gtk.TreeViewColumn('Index',self.cell2,text=1)
    col.set_resizable(True)
    self.treeview.append_column(col)
    self.treeview.append_column(col2)
    ###
    self.dbe_info_dialog = self.xml.get_widget('dbe_info_dialog')
    self.dbe_info_dialog.set_icon_from_file('%s%spyglossary.png'%(srcDir,os.sep))
    self.entry_dbe_info = self.xml.get_widget('entry_dbe_info')
    self.textview_dbe_info = self.xml.get_widget('textview_dbe_info')
    self.treeview_info = self.xml.get_widget('treeview_info')
    table2 = gtk.TextTagTable()
    tag2 = gtk.TextTag('info')
    table2.add(tag2)
    self.buffer_dbe_info = gtk.TextBuffer(table2)
    self.textview_dbe_info.set_buffer(self.buffer_dbe_info)
    self.treestore_info = gtk.ListStore(str)
    self.treeview_info.set_model(self.treestore_info)
    self.cell = gtk.CellRendererText()
    self.cell2 = gtk.CellRendererText()
    col = gtk.TreeViewColumn('Key',self.cell,text=0)
    col.set_resizable(True)
    self.treeview_info.append_column(col)
    #self.vbox4 = self.xml.get_widget('vbox4')
    #ag = gtk.AccelGroup()
    #print dir(gtk.keysyms)
    #ag.connect_by_path('gtk.keysym.Control_L', self.dbe_open)
  def dbe_new(self, *args):
    self.glosE = Glossary()
    self.glosE.data.append(('##name', ''))
    self.treestore.clear()
    self.treestore.append(('##name', 0))
    self.db_ind = 0
    self.db_format = ''
    self.dbe_goto(0, save=False)
    self.dbe_save_as('')
  def dbe_open(self, arg=None):
    format = ''
    fcd = FileChooserDialog(self, combo_items=Glossary.readDesc, action='open')
    fcd.hbox_format.show()
    fcd.combobox.set_active(0)
    fcd.run()
    if self.path in ('',None):
      return False
    self.dbe_path = self.path
    self.fcd_dir = os.path.dirname(self.path)
    self.path = ''
    self.glosE = Glossary()
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    if self.fcd_format=='Auto (by extention)':
      self.glosE.read(self.dbe_path)
    else:
      format = Glossary.descFormat[self.fcd_format]
      self.glosE.read(self.dbe_path, format=format)
    self.fcd_format=''
    self.db_ind=None
    (d,t) = (self.glosE.data,self.treestore)
    t.clear()
    for i in range(len(d)):
      x = d[i]
      t.append((x[0], i))
      #d[i]=(x[0], x[1], True) ## read only
    self.dbe_goto(0, save=False)
    self.running = True
    self.db_format = format
    for key in self.glosE.infoKeys():
      self.treestore_info.append((key,))
    self.info_i=0
    self.dbe_info_goto(0, save=False)
  def dbe_save(self, *args):
    fileCopy(self.dbe_path, self.dbe_path+'~')
    if self.dbe_save_as(self.dbe_path):
      os.remove(self.dbe_path+'~')
    else:
      os.remove(self.dbe_path)
      os.rename(self.dbe_path+'~', self.dbe_path)
      printAsError('Saving file "%s" failed! Backup file restored instaed.'%self.dbe_path)
  def dbe_save_as(self, *args):
    #self.glosE.data[self.db_ind] = (self.entry_dbe.get_text(),self.buffer_dbe.get_text())
    self.dbe_update()
    format = self.db_format
    if type(args[0])==str and args[0]!='' and format in Glossary.writeFormats+('',):
      self.dbe_path = args[0]
      ex = self.glosE.write(self.dbe_path, format=format)
    else:
      fcd = FileChooserDialog(self, combo_items=Glossary.writeDesc, action='save')
      fcd.hbox_format.show()
      fcd.combobox.set_active(0)
      fcd.run()
      if self.path in ('',None):
        return False
      path = self.dbe_path = self.path
      self.path = ''
      self.fcd_dir = os.path.dirname(path)
      if self.fcd_format=='Auto (by extention)':
        ex = self.glosE.write(path)
      else:
        format = Glossary.descFormat[self.fcd_format]
        ex = self.glosE.write(path, format=format)
      self.dbe_path = path
    if ex != False:
      print 'DB file "%s" saved'%self.dbe_path
      self.running = False
      self.db_format = format
      return True
  def dbe_ro_clicked(self, *args):
    ro = self.checkb_db_ro.get_active()
    self.glosE.data[self.db_ind][2] = ro
    self.entry_dbe.set_editable(not ro)
    self.textview_dbe.set_editable(not ro)
  dbe_prev  = lambda self, *args: self.dbe_goto(self.db_ind-1)
  dbe_next  = lambda self, *args: self.dbe_goto(self.db_ind+1)
  dbe_first = lambda self, *args: self.dbe_goto(0)
  dbe_last  = lambda self, *args: self.dbe_goto(-1)
  def dbe_goto_clicked(self, *args):
    ind = self.entry_db_index.get_text()
    try:
      n_ind=int(ind)
    except:
      printAsError('bad index: "%s"'%ind)
      return False
    self.dbe_goto(n_ind)
  def dbe_update(self):
    d = (self.entry_dbe.get_text(),self.buffer_dbe.get_text\
      (self.buffer_dbe.get_start_iter(),self.buffer_dbe.get_end_iter()))
    self.glosE.data[self.db_ind] = d
    self.treestore[self.db_ind][0] = d[0]
  def dbe_update_info(self):
    d = (self.entry_dbe_info.get_text(),self.buffer_dbe_info.get_text\
      (self.buffer_dbe_info.get_start_iter(),self.buffer_dbe_info.get_end_iter()))
    self.glosE.info[self.info_i] = d
    self.treestore_info[self.info_i][0] = d[0]
  def dbe_goto(self, n_ind, save=True):
    p_ind = self.db_ind
    if save:
      p_data = (self.entry_dbe.get_text(),self.buffer_dbe.get_text\
      (self.buffer_dbe.get_start_iter(),self.buffer_dbe.get_end_iter()))
    n = len(self.glosE.data)
    if 0 <= n_ind < n:
      pass 
    elif n_ind == n:
      n_ind = 0
    elif -n < n_ind < 0:
      n_ind += n
    else:
      printAsError('index out of range: "%s"'%n_ind)
      return False
    self.db_ind = n_ind
    d = self.glosE.data[n_ind]
    self.entry_dbe.set_text(d[0])
    try:
      self.entry_db_index.set_text(str(n_ind))### ????????????????????????????????????
    except:
      pass
    self.buffer_dbe.set_text(d[1])
    self.treeview.set_cursor(n_ind)
    #self.checkb_db_ro.set_active(d[2]) ## read only
    if save:#and not self.glosE.data[self.db_ind][2]: ## read only
      self.glosE.data[p_ind] = p_data
      self.treestore[p_ind][0] = p_data[0]
  def dbe_info_goto(self, n_ind, save=True):
    p_ind = self.info_i
    if save:
      p_info = (self.entry_dbe_info.get_text(),self.buffer_dbe_info.get_text\
      (self.buffer_dbe_info.get_start_iter(),self.buffer_dbe_info.get_end_iter()))
    n = len(self.glosE.info)
    """if 0 <= n_ind < n:
      pass 
    elif n_ind == n:
      n_ind = 0
    elif -n < n_ind < 0:
      n_ind += n
    else:
      printAsError('index out of range: "%s"'%n_ind)
      return False"""
    self.info_i = n_ind
    inf = self.glosE.info[n_ind]
    self.entry_dbe_info.set_text(inf[0])
    self.buffer_dbe_info.set_text(inf[1])
    self.treeview_info.set_cursor(n_ind)
    #self.checkb_db_ro.set_active(d[2]) ## read only
    if save:#and not self.glosE.data[self.db_ind][2]: ## read only
      self.glosE.info[p_ind] = p_info
      self.treestore_info[p_ind][0] = p_info[0]
  def dbe_new_w(self, *args):
    n = len(self.glosE.data)
    word = 'word%s'%n
    self.glosE.data.append((word, ''))
    self.treestore.append((word, str(n)))
    self.dbe_goto(n)
    self.entry_dbe.select_region(0, -1)
    self.entry_dbe.do_focus(self.entry_dbe, 0)
  def dbe_del_w(self, *args):
    n = len(self.glosE.data)
    ind = self.db_ind
    self.glosE.data.pop(ind)
    del self.treestore[ind]
    if ind==n-1:
      self.dbe_goto(n-2, False)
    else:
      self.treestore[ind][1] = ind
      self.dbe_goto(ind, False)
      while gtk.events_pending():
        gtk.main_iteration_do(False)
      for i in range(ind+1, n-1):
        self.treestore[i][1] = i
        if i%100==0:
          while gtk.events_pending():
            gtk.main_iteration_do(False)
  def treeview_changed(self, *args):
    try:
      i = self.treeview.get_cursor()[0][0]
    except:
      printAsError('can not get index of treeview curser!')
    else:
      self.dbe_goto(i)
  def treeview_info_changed(self, *args):
    try:
      i = self.treeview_info.get_cursor()[0][0]
    except:
      printAsError('can not get index of treeview_info curser!')
    else:
      self.dbe_info_goto(i)
  def dbe_info_move_back(self, *args):
    g = self.glosE
    s = self.treestore_info
    i = self.info_i
    if i<1:
      return
    (g.info[i], g.info[i-1]) = (g.info[i-1], g.info[i])
    (s[i], s[i-1] ) = (s[i-1], s[i] )
    self.info_i = i-1
    self.dbe_info_goto(self.info_i)
  def dbe_info_move_next(self, *args):
    g = self.glosE
    s = self.treestore_info
    i = self.info_i
    n = len(g.info)
    if i>n-2:
      return
    (g.info[i], g.info[i+1]) = (g.info[i+1], g.info[i])
    (s[i], s[i+1] ) = (s[i+1], s[i] )
    self.info_i = i+1
    self.dbe_info_goto(self.info_i)
  def dbe_info_del(self, *args):
    g = self.glosE
    s = self.treestore_info
    i = self.info_i
    n = len(g.info)
    g.info.pop(i)
    del s[i]
    if i>n-2:
      self.info_i=n-2
    if n==1:
      self.entry_dbe_info.set_text('')
      self.buffer_dbe_info.set_text('')
      self.info_i = -1
    else:
      self.dbe_info_goto(self.info_i, save=False)
  def dbe_info_new(self, *args):
    g = self.glosE
    n = len(g.info)
    if n>0:
      self.dbe_update_info()
    else:
      self.info_i = -1
    i = self.info_i
    nkey = 'key%s'%(i+1)
    g.info.insert(i+1, (nkey,''))
    self.treestore_info.insert(i+1, (nkey,))
    for j in range(i+1, n+1):
      self.treestore_info[j][0] = g.info[j][0]
    self.info_i += 1
    self.dbe_info_goto(self.info_i, False)
    self.entry_dbe_info.select_region(0, -1)
    self.entry_dbe_info.do_focus(self.entry_dbe_info, 0)
  def entry_dbe_activate(self, *args):
    w = self.entry_dbe.get_text()
    i = self.db_ind
    g = self.glosE
    g.data[i] = (w, g.data[i][1])
    self.treestore[i][0] = w
  def entry_dbe_info_activate(self, *args):
    k = self.entry_dbe_info.get_text()
    i = self.info_i
    self.glosE.info[i] = k
    self.treestore_info[i][0] = k
  def dbe_sort(self, *args):
    self.dbe_update()
    if len(self.glosE.data)!=len(self.treestore):
      print len(self.glosE.data),len(self.treestore)
    self.glosE.data.sort()
    for i in range(len(self.glosE.data)):
      self.treestore[i]=[self.glosE.data[i][0], str(i)]
    self.dbe_goto(self.db_ind, False)
  def dbe_info_clicked(self, *args):
    self.dbe_info_dialog.show()
    #print self.glosE.info
  def dbe_info_close(self, *args):
    self.dbe_info_dialog.hide()
    return True
  def pref_init(self, *args):
    self.pref={}
    self.prefKeys=['newline','auto_update','auto_set_for','auto_set_out','sort','remove_tags',\
      'wrap_out','wrap_err',  'wrap_edit','wrap_dbe',\
      'color_bg_out','color_bg_err','color_bg_edit','color_bg_dbe',\
      'color_font_out','color_font_err','color_font_edit','color_font_dbe']
    self.def_widgets(['cb_psyco','checkb_autofor','checkb_autoout','cb_auto_update','cb_c_sort','cb_rm_tags'])
    self.combobox_save = self.xml.get_widget('combobox_save')
    self.combobox_save.set_active(0)
    self.combobox_newline = self.xml.get_widget('combobox_newline')
    self.newlineItems=('\\n', '\\r\\n', '\\n\\r')
    for name in ('out','err','edit','dbe'):
      self.def_widgets(['cb_wrap_%s'%name,'colorpicker_bg_%s'%name,'colorpicker_font_%s'%name])
    self.pref['auto_update'] = self.cb_auto_update.get_active()
    if os.path.isfile(use_psyco_file):
      self.cb_psyco.set_active(True)
    else:
      self.cb_psyco.set_active(False)
    self.prefSavePath=['%s%s.pyglossaryrc'%(homeDir,os.sep),  '%s%src.py'%(srcDir,os.sep)]
    self.pref_load()
    self.pref_update()
  def pref_update(self, *args):
    self.pref['auto_update'] = self.xml.get_widget('cb_auto_update').get_active()
    k = self.combobox_newline.get_active()
    self.pref['newline'] = "'"+self.newlineItems[k]+"'"
    for name in ('out','err','edit','dbe'):
      exec('\
self.pref["wrap_%s"]=self.cb_wrap_%s.get_active()\n\
if self.pref["wrap_%s"]:\n\
  self.textview_%s.set_wrap_mode(gtk.WRAP_WORD)\n\
else:\n\
  self.textview_%s.set_wrap_mode(gtk.WRAP_NONE)'%((name,)*5))
      exec('col=self.colorpicker_bg_%s.get_property(\'color\')'%name)
      exec('self.textview_%s.modify_base(0, gtk.gdk.Color(%s, %s, %s))'%(name,col.red,col.green,col.blue))
      exec('self.pref["color_bg_%s"]=(col.red,col.green,col.blue)'%name)
      exec('col=self.colorpicker_font_%s.get_property(\'color\')'%name)
      exec('self.textview_%s.modify_text(0, gtk.gdk.Color(%s, %s, %s))'%(name,col.red,col.green,col.blue))
      exec('self.pref["color_font_%s"]=(col.red,col.green,col.blue)'%name)
    self.pref['auto_set_for']=self.checkb_autofor.get_active()
    self.pref['auto_set_out']=self.checkb_autoout.get_active()
    self.pref['sort']=self.xml.get_widget('cb_c_sort').get_active()
    self.pref['remove_tags']=self.cb_rm_tags.get_active()
  def pref_save(self, *args):
    self.pref['save']=self.combobox_save.get_active()
    if self.pref['save']==0:
      fp = file(self.prefSavePath[0], 'w')
    elif self.pref['save']==1:
      try:
        fp = file(self.prefSavePath[1], 'w')
      except IOError[13]:
        fp = file(self.prefSavePath[0], 'w')
        self.pref['save']=0
    else:
      return
    ex = os.path.isfile(use_psyco_file)
    if psyco_found==False:
      self.cb_psyco.set_active(False)
      self.cb_psyco.set_senstive(False)
    elif self.cb_psyco.get_active():
      if not ex:
        file(use_psyco_file, 'w').close()
    else:
      if ex:
        os.remove(use_psyco_file)
    if self.pref['save']==1:
      fp.write('save=%s\n'%self.pref['save'])
    for key in self.prefKeys:
      fp.write('%s=%s\n'%(key,self.pref[key]))
  def pref_load(self, *args):
    found=False
    try:
      fp=file('%s%src.py'%(srcDir,os.sep))
    except:
      pass
    else:
      found=True
      for line in fp.read().split('\n'):       
        parts=line.split('=')
        try:
          exec('self.pref["%s"]=%s'%(parts[0],parts[1]))
        except:
          pass
    #if found:
    if self.pref['save']==0:
      try:
        fp=file(self.prefSavePath[0])
      except:
        pass
      else:
        found=True
        for line in fp.read().split('\n'):       
          parts=line.split('=')
          try:
            exec('self.pref["%s"]=%s'%(parts[0],parts[1]))
          except:
            pass
    if not found:
      return
    self.combobox_save.set_active(self.pref['save'])
    self.cb_auto_update.set_active(self.pref['auto_update']) 
    for i in range(len(self.newlineItems)):
      exec('eq=(self.pref["newline"]=="%s")'%self.newlineItems[i])
      if eq:
        self.combobox_newline.set_active(i)
        break
    self.checkb_autofor.set_active(self.pref['auto_set_for'])
    self.checkb_autoout.set_active(self.pref['auto_set_out'])
    self.cb_c_sort.set_active(self.pref['sort'])
    self.cb_rm_tags.set_active(self.pref['remove_tags'])
    #self.combobox_c_case.set_active(self.pref[''])
    for name in ('out','err','edit','dbe'):
      exec('self.cb_wrap_%s.set_active(self.pref["wrap_%s"])'%(name,name))
    for name in ('out','err','edit','dbe'):
      exec('color=self.pref["color_bg_%s"]'%name)
      exec('self.colorpicker_bg_%s.set_property(\'color\', gtk.gdk.Color%s)'%(name,color))
    for name in ('out','err','edit','dbe'):
      exec('color=self.pref["color_font_%s"]'%name)
      exec('self.colorpicker_font_%s.set_property(\'color\', gtk.gdk.Color%s)'%(name,color))
  def pref_auto_clicked(self, *args):
    self.pref['auto_update'] = self.cb_auto_update.get_active()
  def pref_changed(self, *args):
    if self.pref['auto_update']:
      self.pref_update()
  def grab_focus_reverse(self, *args):
    self.label_reverse.grab_focus()
  def progress(self, rat, text=None):
    (stderr,sys.stderr) = (sys.stderr,stderr_saved)
    if text==None:
      text = '%%%d'%(rat*100)
    self.progressbar.update(rat)
    self.progressbar.set_text(text)
    sys.stderr = stderr
  def progressListen(self, sleep=0.1):
    f=file(fifoPath)
    msg=f.readline()
    while msg!='end':
      if msg=='':
        pass
      else:
        if '\n' in msg:
          msg=msg.split('\n')[-1]
        if '\t' in msg:
          parts=msg.split('\t')
          self.progress(float(parts[0]), parts[1])
        else:
          try:
            rat=float(msg)
          except:
            self.progressbar.set_text(msg)
          else:
            self.progressbar.update(rat)
            self.progressbar.set_text('%%%s'%msg)
      while gtk.events_pending():
        gtk.main_iteration_do(True)
      #time.sleep(sleep)
      msg=f.readline()



class FileChooserDialog:
  def __init__(self, main, path='', combo_items=[], action='open', multiple=False):
    self.main = main
    (stderr,sys.stderr) = (sys.stderr,stderr_saved)
    self.xml= gtk.glade.XML('%s%sglade%sfilechooserdialog.glade'%(srcDir,os.sep,os.sep))
    sys.stderr = stderr
    self.fd = self.xml.get_widget("filechooserdialog")
    self.fd.set_action(action)
    self.fd.set_select_multiple(multiple)
    self.hbox_format = self.xml.get_widget('hbox_format')
    signals={}
    for attr in dir(self):
      signals[attr] = getattr(self, attr)
    self.xml.signal_autoconnect(signals)
    if path=='':
      try:
        path = main.fcd_dir
      except:
        pass
    if combo_items!=[]:
      self.combobox=self.xml.get_widget('combobox1')
      for item in combo_items:
        self.combobox.append_text(item)
    if os.path.isdir(path):
      self.fd.set_current_folder(path)
    elif os.path.isfile(path):
      self.fd.set_filename(path)
    else:
      self.fd.set_current_folder(homeDir)
  run=lambda self: self.fd.run()
  cancel_clicked=lambda self, *args: self.fd.destroy()
  def ok_clicked(self, *args):
    self.main.path = self.fd.get_filename()
    try:
      self.main.fcd_format = self.combobox.get_active_text()
    except:
      pass
    self.fd.hide()


class HelpDialog:
  def __init__(self):
    self.xml= gtk.glade.XML('%s%sglade%shelpdialog.glade'%(srcDir,os.sep,os.sep))
    self.d = self.xml.get_widget ("helpdialog")
    self.xml.connect('close',self.close)
    #signals={}
    #for attr in dir(self):
    #  signals[attr] = getattr(self, attr)
    #signals={'close':self.close}
    #try:
    #  self.xml.signal_autoconnect(signals)
    #except:
    #  print signals
  run=lambda self: self.d.run()
  close=lambda self, *args: self.d.destroy()

def help():
  print 'Usage:\n'+\
        '    %s --help\n'%sys.argv[0] +\
        '    %s <INPUT_FILE> -o <OUTPUT_FILE>\n'%sys.argv[0] +\
        'Input and output files formats will be detected as extentions.\n'+\
        '\nSupported input formats:'
  for f in Glossary.readFormats:
    print Glossary.formatsDesc[f]
  print '\nSupported output formats:'
  for f in Glossary.writeFormats:
    print Glossary.formatsDesc[f]

################################################################################################
################################################################################################
################################################################################################
################################################################################################

if __name__=='__main__':
  if os.path.isfile(use_psyco_file):
    try:
      import psyco
    except ImportError:
      print 'Warning: module "psyco" not found. It could speed up execution.'
      psyco_found=False
    else:
      psyco.full()
      #psyco.bind(Glossary)
      #psyco.bind(DummyFile)
      #psyco.bind(MainDialog)
      print 'Using module "psyco" to speed up execution.'
      psyco_found=True
  import thread
  if len(sys.argv)==1:
    #try:
      #import pygtk
      #pygtk.require ('2.0')
      import gtk, gtk.glade
    #except ImportError:
    #  print 'gtk or gtk.glade module not found.'
      ## Here implement a curses UI
    #else:
      ui=MainDialog()
      ui.run()
  elif sys.argv[1] in ('-h', '--help'):
    help()
  else:
    import getopt
    try:
      opt = getopt.gnu_getopt(sys.argv[1:], 'o:re', ['output=','reverse','edit'])
    except getopt.GetoptError:
      printAsError('Invalid usage!') ; help() ; sys.exit(1)
    if len(opt[1])==0:
      printAsError('No input file given!') ; help() ; sys.exit(1)
    iFilename = opt[1][0]
    oFilename = ''
    for item in opt[0]:
      if item[0] in ('-o', '--output'):
        oFilename = item[1]
        break
    if oFilename=='':
      printAsError('No output file given!') ; help() ; sys.exit(1)
    g = Glossary()
    print 'reading file "%s"'%iFilename
    if g.read(iFilename)!=False:
      print 'writing to file "%s"'%oFilename
      if g.write(oFilename)!=False:
        print 'done'
      else:
        printAsError('writing output file was failed!')
    else:
      printAsError('reading input file was failed!')
  #os.remove(fifoPath)  



#tmpFile.close()
#os.remove(tmpFilePath)


